BigDecimal#to_f breaks for numbers too small to be representable in Float

08/28/2012 05:52 PM - adrianomitre (Adriano Mitre)

Status: Closed   

Priority: Normal   

Assignee:    

Target version: 1.9.2   

ruby -v: ruby 1.9.2p290 (2011-07-09 revision

32553) [x86_64-linux]

Backport:  

Description

BigDecimal numbers too small to be representable in Float are incorrectly converted to +/-Infinity instead of 0.0 (or -0.0). Things

seem to broke down when exponent is about -308.

with 307, ok

BigDecimal('1e-307').to_f

=> 1.0e-307

BigDecimal('-1e-307').to_f

=> -1.0e-307

with 308, broken but signedness is correct

BigDecimal('1e-308').to_f

=> Infinity

BigDecimal('-1e-308').to_f

=> -Infinity

with 350 not even signedness is correct

BigDecimal('1e-350').to_f

=> -Infinity

BigDecimal('-1e-350').to_f

=> -Infinity

Workaround: resort to BigDecimal#to_s and Float(.)

x=BigDecimal('1e-350')

Float(x.to_s)

Associated revisions

Revision d7ca01a73ad5287f9d063bbdf5b35f472affda9d - 08/30/2012 07:17 AM - nobu (Nobuyoshi Nakada)

bigdecimal.c: check underflow

ext/bigdecimal/bigdecimal.c (BigDecimal_to_f): check underflow since

strtod() sets errno to ERANGE at underflow too.  [ruby-core:47342]

07/18/2025 1/2



[Bug #6944]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@36854 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d7ca01a7 - 08/30/2012 07:17 AM - nobu (Nobuyoshi Nakada)

bigdecimal.c: check underflow

ext/bigdecimal/bigdecimal.c (BigDecimal_to_f): check underflow since

strtod() sets errno to ERANGE at underflow too.  [ruby-core:47342]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@36854 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 08/30/2012 04:17 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r36854.

Adriano, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.
